// \ʎt[u
// create 2006/06/13 by codera

#include <hidef.h>
#include "derivative.h"

#define	ANODE1		PTBD_PTBD7		// 7ZOLED ʃAm[h1
#define	ANODE2		PTAD_PTAD3		// 7ZOLED ʃAm[h2
#define	ANODE3		PTAD_PTAD2		// 7ZOLED ʃAm[h3

#define	BUZZER		PTAD_PTAD0		// duU[
#define	HEATER		PTAD_PTAD4		// q[^[|[g
#define	SWITCH		PTAD_PTAD5		// vt@CI{^

#define MAX_PROFILE	3				// ővt@C
#define AVE_THERMO	4				// KMdΕσTv

#define K_THERMO	5				// \xW

enum{
	BUZZ_PI,
	BUZZ_PIPI,
	BUZZ_PIRORI,
	BUZZ_PIPIPI
};

unsigned char	ADCWait=0;			// ADCEFCg
unsigned char	MTMWait=0;			// W^C}EFCg
unsigned char	SecWait=0;			// bJEgEFCg
unsigned char	Sec=0;				// bJE^

unsigned char	Thermo_L=0;			// KMd΂擾x(ʃoCg)
unsigned char	Thermo_H=0;			// KMd΂擾x(ʃoCg)
unsigned int	Thermo=0;			// KMd΂擾x

unsigned int	LogThermo[AVE_THERMO];	// KMd΂̉xL^obt@
unsigned char	LogPos=0;			// ݂̉xL^|C^
unsigned int	AveThermo=0;		// KMd΂̕ωx
unsigned int	PrevThermo=0;		// O̕ωx

unsigned char	CurLED=0;			// ݕ\LEDAm[hԍ
unsigned char	Digit[3]={0,0,0};	// \7ZOl
unsigned char	Blink=0;			// uN[h

unsigned char	Profile=1;			// ݂̃vt@Cԍ
unsigned char	ProfCount=0;		// vt@C\c莞
unsigned char	Prof[3]={0,12,11};	// \̃vt@C7ZOl

// 7ZOLED̕\f[^
#ifdef USE_CATHOD_COMMON			// J[\[hRLEDgꍇ
unsigned char	NumFig[14]={0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7c,0x07,0x7f,0x67 ,0x00,0x73,0x40};
#define	LED_ON	0
#define LED_OFF	1
#else								// Am[hRLEDgꍇiWj
unsigned char	NumFig[14]={~0x3f,~0x06,~0x5b,~0x4f,~0x66,~0x6d,~0x7c,~0x07,~0x7f,~0x67 ,~0x00,~0x73,~0x40};
#define	LED_ON	1
#define LED_OFF	0
#endif

void MCU_init(void);

void InitPorts() {
	// PTA0(TPMCH0)	OUT	dXs[J
	// PTA1(ADP1)	IN	MdΓ
	// PTA2			OUT	LCD COM3
	// PTA3			OUT	LCD COM2
	// PTA4(BKGD)	OUT	HEATER
	// PTA5(/RESET)	IN	^NgSWITCH
	// PTB0-PTB6	OUT	7SEG LED
	// PTB7			OUT	LCD COM1

	SOPT1=0xd0;		// Disable BKGDPE/RSTPE

	// Disable pull-ups on all input pins
	PTAPE = 0x20;	// ^NgSŴON
	PTBPE = 0x00;

	// |[gÄꕔo(PTA0,PTA2,PTA3,PTA4)
	PTADD = 0x1d;

	// |[gBo
	PTBDD = 0xFF;
}

// PWM
void InitPWM(void){
	TPMSC   = 0x00;	// stop timer
	TPMC0SC = 0x24;	// set channel 1 for PWM
}

// PWMX^[g
void StartPWM(int n){
	// W n=1000	4kHz
	TPMMOD = n;
	TPMC0V = (n>>1);
	TPMSC  = 0x08;	// select bus clock and start timer
}

// PWM~
void StopPWM(void){
	TPMSC  = 0x00;	// stop timer
	BUZZER = 0;
}

// W^C}
void InitTimer(void){
	MTIMCLK_PS   = 8;
	MTIMCLK_CLKS = 0;

	MTIMMOD = 77;   // modulo = 77 , Int:5ms
	MTIMSC  = 0x60; // reset and start MTIM, enable ints

	MTIMSC_TSTP=0;
}

// ADC
void InitADC(void){
	ADCSC1 = 0x5F;  // Enable interrupts 
					// Disable continuous conversions
					// Disable ADC by setting all ADCH bits
	ADCSC2 = 0x00;  // Select S/W trigger
         			// Disable compare function
	ADCCFG = 0x8B; 	// ADLPC=Low power
					// ADIV=input clock/8
                    // ADLSMP=long sample time
                    // MODE=10bit conversion
                    // ADICLK=bus clock
	APCTL1 = 0x02;  // Enable pins 1 as ADC inputs
}

// msecPʂ̑ҋ@
void Wait(int tick){
	MTMWait=(unsigned char)(tick/5);	// 5ms
	while(MTMWait){
		__RESET_WATCHDOG(); // feeds the dog
	}
}

// ^NgSWITCȞoi`^O}~10msec)
char IsPressSW(void){
	if(SWITCH==0){
		Wait(10);
		if(SWITCH==0)
			return 1;
	}
	return 0;
}

// XCb`͑҂imsecPʂ̑ҋ@j
char WaitSwitch(int tick){
	MTMWait=(unsigned char)(tick/5);	// 5ms
	while(MTMWait){
		if(IsPressSW())
			return 1;
		__RESET_WATCHDOG();
	}
	return 0;
}

// XCb`[X҂
void WaitRelease(int tick){
	MTMWait=(unsigned char)(tick/5);	// 5ms
	while(MTMWait){
		if(SWITCH==1)
			break;
		__RESET_WATCHDOG();
	}
}

// PWMuU[ݒ
void Buzzer(char type){
	switch(type){
		case BUZZ_PI:
			// Buzzerisbj
			StartPWM(1000);
			Wait(100);
			StopPWM();
			break;
		case BUZZ_PIPI:
			// Buzzerissj
			StartPWM(1000);
			Wait(100);
			StopPWM();
			Wait(100);
			StartPWM(1000);
			Wait(100);
			StopPWM();
			break;
		case BUZZ_PIRORI:
			// Buzzerisj
			StartPWM(1100);
			Wait(100);
			StopPWM();
			StartPWM(1000);
			Wait(100);
			StopPWM();
			StartPWM(900);
			Wait(100);
			StopPWM();
			break;
		case BUZZ_PIPIPI:
			// Buzzeris[s[s[j
			StartPWM(1000);
			Wait(1000);
			StopPWM();
			Wait(1000);
			StartPWM(1000);
			Wait(1000);
			StopPWM();
			Wait(1000);
			StartPWM(1000);
			Wait(1000);
			StopPWM();
			break;
	}
}

// vt@CIiύXу^C}ݒj
void SetProfile(void){
	HEATER=0;
	Buzzer(BUZZ_PI);
	ProfCount=5;
	Prof[0]=Profile;
}

// x\֐
int Temperature(unsigned int thermo,unsigned int *prev){
	int	temp;
	// ۂ̉x\
	// T=Ts+k*(dTs/dS)
	temp=thermo+K_THERMO*(thermo-*prev);
	*prev=thermo;
	return temp;
}

// wvt@Cs
char DoProfile(int target,unsigned char time){
	Sec=0;
	while(Sec<time) {
		if(ProfCount>0){
			// vt@Cԍ\̓JEgȂ
			Sec=0;
		}else{
			if(Temperature(AveThermo,&PrevThermo)<target){
				// \zxݒ艷x̏ꍇq[^ON
				HEATER=1;
			}else{
				HEATER=0;
			}
		}
		if(WaitSwitch(1000)){
			// XCb`ꂽ
			Profile++;
			if(Profile>MAX_PROFILE)
				Profile=1;
			SetProfile();
			WaitRelease(500);
			return 0;
		}
		__RESET_WATCHDOG();
	}
	return 1;
}

// C֐
void main(void) {
	ICSTRM=NV_ICSTRM;	// IV[^̍Zl[h
	ICSSC=NV_FTRIM;

	InitPorts();
	InitTimer();
	InitADC();
	InitPWM();

	EnableInterrupts;	// Enable interrupts

	SetProfile();
	for(;;){
		if(Profile==1){
			// Wt[
			//  110 60b
			if(!DoProfile(110,60))
				continue;
			Buzzer(BUZZ_PIPI);
			// vq[g 150 120b
			if(!DoProfile(150,120))
				continue;
			Buzzer(BUZZ_PIRORI);
			// t[ 210 60b
			if(!DoProfile(210,60))
				continue;
		}else if(Profile==2){
			// Pbt[pt[
			//  110 60b
			if(!DoProfile(110,60))
				continue;
			Buzzer(BUZZ_PIPI);
			// vq[g 200 120b
			if(!DoProfile(200,120))
				continue;
			Buzzer(BUZZ_PIRORI);
			// t[ 210 60b
			if(!DoProfile(240,60))
				continue;
		}else if(Profile==3){
			// NCbNt[iMɎアipj
			//  110 60b
			if(!DoProfile(110,60))
				continue;
			Buzzer(BUZZ_PIPI);
			// vq[g 130 90b
			if(!DoProfile(130,90))
				continue;
			Buzzer(BUZZ_PIRORI);
			// t[ 200 45b
			if(!DoProfile(200,45))
				continue;
		}
		break;
	}
	// q[^~
	HEATER=0;
	Buzzer(BUZZ_PIPIPI);
	Blink=1;
	// ~
	for(;;) {
		__RESET_WATCHDOG();
	}
}

// A/D荞
interrupt 19 void ADC_ISR(void){
	unsigned char	i;
	unsigned int	total=0;
	Thermo_H = ADCRH;
	Thermo_L = ADCRL;
	Thermo   = (Thermo_H<<8)|Thermo_L;
	Thermo   = Thermo*75/256;

	// ϒlZo
	LogThermo[LogPos]=Thermo;
	LogPos=(LogPos+1)&(AVE_THERMO-1);
	for(i=0;i<AVE_THERMO;i++){
		total+=LogThermo[i];
	}
	AveThermo=total/AVE_THERMO;

	Digit[0] = AveThermo%10;
	Digit[1] = (AveThermo/10)%10;
	Digit[2] = (unsigned char)(AveThermo/100);
	if(Digit[2]==0){
		Digit[2]=10;	// \Ȃ
		if(Digit[1]==0)
			Digit[1]=10;// \Ȃ
	}
}

// W^C}荞
interrupt 12 void MTIM_ISR(void){
	MTIMSC_TOF=0;     // clear TOF

	if(ProfCount)
		PTBD=NumFig[Prof[CurLED]];
	else
		PTBD=NumFig[Digit[CurLED]];

	ANODE3=LED_OFF;
	ANODE2=LED_OFF;
	ANODE1=LED_OFF;
	if(Blink && (Sec&1)){
		// uN͊bŕ\OFF
	}else{
		if(CurLED==0)
			ANODE1=LED_ON;
		else if(CurLED==1)
			ANODE2=LED_ON;
		else
			ANODE3=LED_ON;
	}

	CurLED++;
	if(CurLED>2)
		CurLED=0;

	ADCWait++;
	if(ADCWait>=100){
		// ADC Start
		ADCSC1_ADCH = 1;	// ADC ch:AD1
		ADCWait=0;
	}
	SecWait++;
	if(SecWait>=200){
		// 1sec
		SecWait=0;
		Sec++;
		if(ProfCount){
			ProfCount--;
		}
	}
	if(MTMWait)
		MTMWait--;
}
